// generate mult_add module
// by Wei Zhang
//

#include <stdio.h>

int genmult_add(char * addname, char * multname, int precision)
{
	FILE *fp;

	fp = fopen("mult_add.v", "w");

	fprintf(fp, "module mult_add (clk, A, B, C, mult_result, add_result);\n");
	fprintf(fp, "\n");
	fprintf(fp, "parameter PRECISION = %i;\n", precision);
	fprintf(fp, "\n");
	fprintf(fp, "input clk;\n");
	fprintf(fp, "input [PRECISION-1:0] A, B, C;\n");
	fprintf(fp, "output [PRECISION-1:0] mult_result, add_result;\n");
	fprintf(fp, "\n");
	fprintf(fp, "reg [PRECISION-1:0] out;\n");
	fprintf(fp, "wire [PRECISION-1:0] mult_comp_result;\n");
	fprintf(fp, "reg [PRECISION-1:0] add_a, add_b;\n");
	fprintf(fp, "\n");
	fprintf(fp, "	%s mult_comp (\n", multname);
	fprintf(fp, "		.clock (clk),\n");
	fprintf(fp, "		.dataa (A),\n");
	fprintf(fp, "		.datab (B),\n");
	fprintf(fp, "		.result (mult_comp_result));\n");
	fprintf(fp, "	\n");
	fprintf(fp, "	%s adder_comp (\n", addname);
	fprintf(fp, "		.clock (clk),\n");
	fprintf(fp, "		.dataa (add_a),\n");
	fprintf(fp, "		.datab (add_b),\n");
	fprintf(fp, "		.result (add_result));\n");
	fprintf(fp, "\n");
	fprintf(fp, "	always @ (posedge clk)\n");
	fprintf(fp, "	begin\n");
	fprintf(fp, "		add_a <= C;\n");
	fprintf(fp, "		add_b <= mult_comp_result;\n");
	fprintf(fp, "	end\n");
	fprintf(fp, "	\n");
	fprintf(fp, "	assign mult_result = mult_comp_result;\n");
	fprintf(fp, "\n");
	fprintf(fp, "endmodule\n");

	return 0;
}
