// generate LU module
// by Wei Zhang
//

#include <stdio.h>
#include <string.h>

void gensdc(const char * name, const char * divname, int compclktick, int intdivlat)
{
    FILE *fp;
    int len;
    char filename[500];

    strcpy(filename, name);
    len = strlen(filename);
    strcpy(filename+len, ".sdc");

    fp = fopen(filename, "w");

	fprintf(fp, "\n");
	fprintf(fp, "# ** Clock Latency\n");
	fprintf(fp, "#    -------------\n");
	fprintf(fp, "set_time_format -unit ps -decimal_places 0\n");
	fprintf(fp, "create_clock -period %i -waveform {0.000 %i} -name clk clk\n", compclktick, compclktick/2);
	fprintf(fp, "\n");
	fprintf(fp, "# ** Multicycles\n");
	fprintf(fp, "#    -----------\n");
	fprintf(fp, "set_multicycle_path -setup -end -from {LU:compBlock|LUControl:conBlock|m*} -to {LU:compBlock|LUControl:conBlock|mdivk*} %i\n", intdivlat);
	fprintf(fp, "set_multicycle_path -hold -end -from {LU:compBlock|LUControl:conBlock|m*} -to {LU:compBlock|LUControl:conBlock|mdivk*} %i\n", intdivlat);
	fprintf(fp, "set_multicycle_path -setup -end -from {LU:compBlock|%s:rec|*} -to {LU:compBlock|%s:rec|*} 50\n", divname, divname);
	fprintf(fp, "set_multicycle_path -hold -end -from {LU:compBlock|%s:rec|*} -to {LU:compBlock|%s:rec|*} 50\n", divname, divname);
	fprintf(fp, "set_multicycle_path -setup -end -from {MarshallerController:MC|N*} -to {MarshallerController:MC|Ndivk*} %i\n", intdivlat);
	fprintf(fp, "set_multicycle_path -hold -end -from {MarshallerController:MC|N*} -to {MarshallerController:MC|Ndivk*} %i\n", intdivlat);
	fprintf(fp, "\n");
	fprintf(fp, "# ---------------------------------------------\n");
	fprintf(fp, "\n");

    fclose(fp);
}
